#!/usr/bin/env ruby

## Usage: ruby show-ypath.rb ypath datafile.yaml

require 'yaml'
require 'pp'

## YPath ѥ
ypath = ARGV.shift
unless ypath
   $stderr.puts "Usage: show-ypath ypath [file.yaml ...]"
   exit(0)
end

## YAML եɤ߹ߡĥ꡼Ѵ
str = ARGF.read()
tree = {{*YAML.parse(str)*}}

## ĥ꡼õypath ˥ޥåΡɤΥѥ򤹤٤ɽ
puts "#--- search('#{ypath}') ---"
paths = {{*tree.search(ypath)*}}    # paths ϥѥ
paths.each do |path|
  pp path
end

## ĥ꡼õypath ˥ޥåΡɤ򤹤٤ɽ
puts "#--- select('#{ypath}') ---"
nodes = {{*tree.select(ypath)*}}    # nodes ϥΡɤ
nodes.each do |node|
  obj = {{*node.transform*}}    # Ρɤ򥪥֥ȤѴ
  pp obj
end
## ޤ
# objs = {{*tree.select!(ypath)*}}
# objs.each do |obj|
#   pp obj
# end
